//
//  MyAmazon.h
//  Gamepedia
//
//  Created by Conor Dearden on 18/2/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MyPediaPlugin.h"



@interface MyAmazon : NSObject {
	NSMutableArray *resultsTitle;
	NSMutableArray *resultsASIN;
	NSString *media, *sortOrder, *urlString;
	NSDate *lastSearch;
	id delegate;
	
	BOOL calledWithin;
	int page, totalResults, resultsPerPage;
	
	NSString *currentLocale, *currentLanguage;
	MKProgramType programType;
	
	NSString *accessKey, *associateTag, *secretKey;
    
    NSDictionary *associateTags;
	
	IBOutlet NSTextField *accessKeyTextField;
	IBOutlet NSTextField *associateTagTextField;
	IBOutlet NSSecureTextField *secretKeyTextField;
	IBOutlet NSTextField *descriptionField;
	
	IBOutlet NSProgressIndicator *progressIndicator;
	
}

@property (strong, nonatomic) NSArray *topLevelObjects;
@property (strong, nonatomic) NSDate *lastSearch;

+ (NSString *)cleanString:(NSString *)string;
+ (NSString *)amazonURLForAsin:(NSString *)asin locale:(NSString *)locale entry:(MOEntry *)anEntry;

- (id)initWithLocale:(NSString *)aLocale;
- (NSInteger)totalResults;


- (void)searchFor:(NSDictionary *)searchDict sender:(id)sender; //This becomes the entry search, should only be a dictionary for entry, but it also works as a fallback for old plugins that handle "keyword" as the regular search
- (NSArray *)resultsTitles;
- (NSDictionary *)resultNumber:(NSInteger)number;

//This is the new plug-in search method, that includes options for limit, media and sorting
- (void)searchForString:(NSString *)aString limit:(NSInteger)aLimitNumber type:(NSInteger)mediaNumber sort:(NSInteger)sortNumber sender:(id)sender;




//- (NSString *)findLocaleForASIN:(NSString *)aString;

- (NSString *)associateTag;

- (NSString *)baseDomain;	

- (int)resultsPerPage;

- (NSDictionary *)dictionaryForAsin:(NSString *)asin;

+ (BOOL)hasSettings;
- (IBAction)closeSettings:(id)sender;
- (IBAction)showHelp:(id)sender;

- (IBAction)configureAmazonSettings:(id)sender;

- (IBAction)openAmazon:(id)sender;

@end
