/* MyImport */

#import <Cocoa/Cocoa.h>
#import <ScriptingBridge/ScriptingBridge.h>

@class MyControllerShared;

@interface MyImport : NSObject
{
    IBOutlet NSPanel *importPanel;
    IBOutlet NSTableView *importingTable;
    IBOutlet MyControllerShared *controller;
	IBOutlet NSTextField *notesTextField;
	
	IBOutlet NSPanel *importItunesPanel;
	IBOutlet NSPopUpButton *itunesCollectionsPopUp;
	
    NSArray *importingFields;
    NSPopUpButtonCell *popCell;
    NSMutableArray *importToFields, *menuItemList;
    
}

- (NSMutableSet *)importTabComa:(NSString *)csvString;

- (NSPanel *)importItunesPanel;
- (NSPopUpButton *)itunesCollectionsPopUp;

+ (void)lookForDeliciousCollectionToImport;
+ (BOOL)importDeliciousLibrary2ViaCoreData:(NSString *)filePath addShelves:(BOOL)shelves;
+ (NSMutableSet *)importDeliciousLibraryXMLPath:(NSString *)filePath addShelves:(BOOL)shelves;
+ (NSMutableSet *)importDVDManagerPath:(NSString *)aPath;
+ (NSMutableSet *)importDVDTechPath:(NSString *)aPath;
+ (NSMutableSet *)importDVDAttachePath:(NSString *)aPath;
+ (NSMutableSet *)importDVDCache2Path:(NSString *)aPath;
+ (NSMutableSet *)importDVDCachePath:(NSString *)aPath;
+ (NSMutableSet *)importDVDJugglerPath:(NSString *)aPath;
+ (NSMutableSet *)importAntMovieCatalogPath:(NSString *)aPath;
+ (NSMutableSet *)importInteliscannerCollectionPath:(NSString *)aPath;
+ (NSMutableSet *)importMyMoviesProgram:(NSString *)aPath;
+ (NSMutableSet *)importDVDProfiler24XML:(NSString *)anXMLString atPath:(NSString *)aPath;
+ (NSMutableSet *)importDVDProfiler25XML:(NSString *)anXMLString atPath:(NSString *)aPath;
+ (NSMutableSet *)importDVDCollectorzXML:(NSString *)incomingString;
+ (NSMutableSet *)importSaphirePath:(NSString *)aPath;

+ (BOOL)importXBMCFile:(NSString *)pathToFile;
+ (NSMutableSet *)importMoviesHDiPadXML:(NSString *)incomingString withPath:(NSString *)pathToFile;

+ (NSMutableSet *)importItunesMoviesFromXMLPath:(NSString *)aPath;
+ (BOOL)lookForiTunesImage:(NSString *)persistentID entry:(MOEntry *)anEntry from:(SBElementArray *)entireiTunesLibrary;
+ (NSMutableSet *)importDVDhunterXML:(NSString *)incomingString withPath:(NSString *)pathToFile;


+ (NSMutableSet *)importBookHunterXML:(NSString *)incomingString withPath:(NSString *)pathToFile;
+ (NSMutableSet *)importBibtex:(NSString *)anXMLString;
+ (NSMutableSet *)importEndNoteXML:(NSString *)anXMLString;
+ (NSMutableSet *)importBooxterXML:(NSString *)anXMLString atPath:(NSString *)aPath;
+ (NSMutableSet *)importBookTrackerXML:(NSString *)anXMLString atPath:(NSString *)aPath;
+ (NSMutableSet *)importBookCollectorzXML:(NSString *)incomingString path:(NSString *)filePath isComic:(BOOL)comic;
+ (NSMutableSet *)importBooksXML:(NSString *)incomingString folder:(NSString *)aPath;
+ (NSMutableSet *)importItunesBooksFromXMLPath:(NSString *)aPath;
+ (NSMutableSet *)importGoogleBooksFile:(NSString *)aPath;

//+ (NSMutableSet *)importInteliscannerCollectionBooksPath:(NSString *)aPath;

//+ (NSMutableSet *)importInteliscannerCollectionCDsPath:(NSString *)aPath;
+ (NSMutableSet *)importMusicCollectorzXML:(NSString *)incomingString;
+ (NSMutableSet *)importICDcXML:(NSString *)incomingString;
+ (BOOL)importInCDiusCD:(NSString *)incomingPath;
+ (NSMutableSet *)importDiscoGSXML:(NSString *)incomingString;



+ (NSMutableSet *)importGameCollectorzXML:(NSString *)incomingString;
+ (NSMutableSet *)importGCGamesXML:(NSString *)incomingString path:(NSString *)aPath;
//+ (NSMutableSet *)importInteliscannerCollectionGamesPath:(NSString *)aPath;

@end
