/* MyLinksManager */

#import <Cocoa/Cocoa.h>
#import "MOLink.h"

@class MyWebView, MyControllerShared;

@interface MyLinksManager : NSTableView <NSTableViewDataSource, NSTableViewDelegate, NSOpenSavePanelDelegate>
{
	//IBOutlet NSTextField *URLTextField;
	//IBOutlet NSTextField *commentsTextField;
	//IBOutlet NSButton *linkButton;
	IBOutlet NSButton *viewButton;
	IBOutlet NSButton *downloadButton;
	//IBOutlet NSTabView *tabView;
//	NSColor *sStripeColor;

	IBOutlet MyWebView *webView;
	NSArray *attributesKeys;

	
	NSArrayController *linksArrayController;
	
	BOOL possibleOrphans;
}
-(void)mySetup;
- (void)setEntry:(MOEntry *)anEntry;
- (void)updateEntry:(MOEntry *)anEntry;
- (BOOL)setFromDictionary:(NSDictionary *)aDictionary atSelection:(BOOL)atSelection;


- (void)deselectTable;
- (IBAction)deleteSelected:(id)sender;
- (IBAction)addNewRow:(id)sender;

//- (NSMutableArray *)links;
//- (void)setLinks:(NSMutableArray *)someLinks;
- (void)addLinks:(NSMutableArray *)aData;
+ (MOLink *)addURLAsLink:(NSString *)aLinkURL toEntry:(NSManagedObject *)anEntry;
+ (NSMutableDictionary *)createNewLinkOutOfURL:(NSString *)aURL;
//- (IBAction)textDoneEditing:(id)sender;

- (IBAction)viewURL:(id)sender;
- (IBAction)downloadResource:(id)sender;

- (IBAction)selectFileToLink:(id)sender;

//- (void)addLinksTo:(NSManagedObject *)anEntry;
//- (void)setLinksFrom:(NSManagedObject *)anEntry;

- (BOOL)displayDownloadButton;
- (BOOL)displayViewButton;

- (NSString *)moveFileToDownloadsFolder:(NSString *)aPath withName:(NSString *)aName;


@end
