/* MyPanel */

#import <Cocoa/Cocoa.h>

@class MyEditView, MyEditViewLeft, MyAddPanelFooter, MyCreditsData, MyTracksData, MyAddPanelHeader, MyControllerShared; //, MyInternetSearchView;

@interface MyPanel : NSPanel <NSWindowDelegate>
{
    IBOutlet MyControllerShared *controller;
	
	IBOutlet NSTabView *tabView;

	IBOutlet MyCreditsData *creditData;
	IBOutlet MyTracksData *trackData;
	
	IBOutlet MyAddPanelHeader *header;
	IBOutlet MyAddPanelFooter *footer;
	
    IBOutlet NSButton *backButton;
    IBOutlet NSButton *nextButton;
    IBOutlet NSButton *newSearchButton;
	
	IBOutlet MyEditViewLeft *leftView;
	IBOutlet MyEditView *rightView;
	IBOutlet MyEditView *extraView;
	IBOutlet MyEditView *thirdView;
    
    NSResponder *previousResponder;

	//IBOutlet NSButton *showAllButton;
	
	//### add all the controls to the add panel and call them with getter methods
	//IBOutlet NSTabView *tabView;
	
	IBOutlet NSButton *addButton;
	
	//NSUndoManager *undoManager;
	
	//Internet search view
	//IBOutlet MyInternetSearchView *searchView;
    
    NSMutableArray *inactiveFields;
	
	BOOL windowNeedsFieldsUpdate;
    BOOL holdResponder;
	//BOOL previewMode;
	//NSObjectController *selectedEntryController;
	MOEntry *selectedEntry;
	//MOEntry *previewEntry;
	
	NSMutableDictionary *hiddenValues;
	NSMutableDictionary *baseAddDictionary;
}

@property (readonly) NSTabView *tabView;
@property (assign) BOOL holdResponder;
@property (nonatomic, retain) NSMutableDictionary *baseAddDictionary;


- (void)setupEditFields;

- (IBAction)showAllFields:(id)sender;
- (void)showAll:(BOOL)aBool;


- (MyEditView *)rightView;
- (MyEditView *)extraView;
- (MyEditView *)thirdView;


- (void)setImage:(NSImage *)anImage;

- (MOEntry *)selectedEntry;

//To pass on to edit panels
- (void)clearPanel;
- (void)setEntry:(MOEntry *)anEntry;
- (void)setFromDictionary:(NSDictionary *)aDictionary;
- (void)setFromDictionaryWithRollback:(NSDictionary *)aDictionary;
- (NSMutableDictionary *)entryDictionary;
- (void)updateEntry:(MOEntry *)anEntry;
- (void)activeFieldsChanged;

- (id)valueForKey:(NSString *)aString;
- (void)setValue:(id)anObject forKey:(NSString *)aString;

//- (void)addPreviewEntry:(MOEntry *)anEntry;
//- (MOEntry *)makePreviewEntryPermanent;
//- (NSObjectController *)selectedEntryController;
- (MyCreditsData *)creditData;
- (MyTracksData *)trackData;

- (MyAddPanelFooter *)footer;

- (void)changesMade;
- (IBAction)cancelButton:(id)sender;

@end
