/* MyPluginManager */

//#import <Cocoa/Cocoa.h>
#import "MyPediaPlugin.h"
@class MyControllerShared, MyAmazon;

enum {
	MKAdvanceSearch = 1,
	MKCoverSearch = 2
};

@interface MyPluginManager : NSObject <NSTableViewDataSource, NSTableViewDelegate>
{
	NSMenu *pluginMenu;  //menu plugin with plugin picture on main menu
	IBOutlet NSMenu *advanceMenu;  //under the advance menu
	IBOutlet NSMenu *advanceMenuContextual; //table contextual
	IBOutlet NSButton *addPanelGearButton;  //add panel
	
	//IBOutlet NSMenu *downloadCoverMenu; 
	IBOutlet NSMenu *downloadCoverMenuContextual;
	//IBOutlet NSMenu *downloadCoverMenuImage;

	IBOutlet MyControllerShared *controller;
	NSTableView *pluginTable;  //In the preferences
	
	NSMutableDictionary *menuPluginTitles, *pluginsSearchPlugins;
	NSMutableArray *pluginsSearch;
	NSMutableArray *pluginsForSearch;
	
	NSUInteger searchMode;
	MyPediaPlugin *currentSearchPlugin;
	NSMutableArray *entriesToUpdate;
	MOEntry *currentEntry;
	
	//MyAmazon *amazon;
}

@property (nonatomic,retain) NSTableView *pluginTable;
@property (readonly) NSMenu *advanceMenu;

- (void)executeMenuPlugin:(id)sender;
- (NSArray *)pluginsForSearch;
- (id)pluginForName:(NSString *)name;

- (BOOL)addPlugin:(id)plugin withName:(NSString *)name;
- (void)removePluginWithName:(NSString *)name;

- (void)setOrderFromPrefs;
- (void)setupPluginMenu;
- (NSArray *)pluginsSearch;

// Exposed to plug-ins
//+ (MyPluginManager *)sharedPluginManager;
- (void)addMenuItem:(NSMenuItem *)anItem menuTitle:(NSString *)menuTitle; // Called by the plug-ins to add menu items

// - (void)addEntriesWithAttributes:(NSArray *)entries;
//- (NSManagedObject *)selectedEntry;
//- (NSArray *)arrangedEntries;
//- (NSArray *)selectedEntries;

- (IBAction)downloadCovers:(id)sender;

- (IBAction)amazonTest:(id)sender;
- (void)removeAllAmazons;
- (void)addAmazonsTriggerReload:(BOOL)reload;


//- (IBAction)configureAmazonSettings:(id)sender;


@end
